/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.6 Standard
Automatic Program Generator
 Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com
e-mail:office@hpinfotech.com

Project : 
Version : 
Date    : 18.07.2008
Author  : Mike                            
Company : megamilas                       
Comments: 


Chip type           : ATmega8515
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*****************************************************/

#include	<mega8515.h>
#include	"Hw.h"

unsigned char	MidiChannel;
unsigned char	MidiProgramm;
unsigned char	StoredChannel;
unsigned char	LastReceivedProgramm;
unsigned char	LastReceivedChannel;
unsigned short	FrontSwitchMajority[4];
unsigned char	FootSwitchMajority[4];
unsigned short	RelayState;
unsigned short	HwRelayState;
unsigned short	FrontSwitchState;
unsigned short	PrevFrontSwitchState;
unsigned char	FootSwitchState;
unsigned char	PrevFootSwitchState;
unsigned char	DelayValue;

unsigned long	EeValue;
unsigned short	EeProgAddr;
unsigned short	ProgLen;
unsigned char*	EePtr;

bit	prgChangeDetectedBefore;
bit	SwitchSettingsAltered;

bit	EeProgReq;
bit	EeProgProgress;
bit	NextEeProgReq;

// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
	unsigned char	inByte;
	inByte = UCSRA;
	inByte = UDR;

	if ((inByte & 0x80) != 0)
	{	// Command
		if ((inByte & 0xF0) == 0xC0)
		{
			prgChangeDetectedBefore = 1;
			MidiChannel = inByte & 0x0F;
		}
		else
			prgChangeDetectedBefore = 0;
	}
	else
	{	// Data
		if (prgChangeDetectedBefore != 0)
		{
			prgChangeDetectedBefore = 0;
			MidiProgramm = (inByte & 0x7F);
		}
	}
}

// USART Transmitter interrupt service routine
interrupt [USART_TXC] void usart_tx_isr(void)
{
	UCSRB &= ~0x40;
}

interrupt	[EE_RDY] void ee_rdy_isr(void)
{
	EECR = 0;
	if (EeProgProgress)
		NextEeProgReq = 1;
}

// Timer 1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
	OCR1A += 5000;	// 5 mS
	FrontSwitchMajority[1] = FrontSwitchMajority[2];
	FrontSwitchMajority[2] = FrontSwitchMajority[3];
	FrontSwitchMajority[3] = ((PINC & 0x3F) | (((unsigned short)(PIND & 0xFE)) << 5)) ^ 0x1FFF;
	FrontSwitchMajority[0] = ((FrontSwitchMajority[2] | FrontSwitchMajority[3]) & FrontSwitchMajority[1])
		| (FrontSwitchMajority[2] & FrontSwitchMajority[3]);
	FootSwitchMajority[1] = FootSwitchMajority[2];
	FootSwitchMajority[2] = FootSwitchMajority[3];
	FootSwitchMajority[3] = (PINB & 0xFC) ^ 0xFC;
	FootSwitchMajority[0] = ((FootSwitchMajority[2] | FootSwitchMajority[3]) & FootSwitchMajority[1])
		| (FootSwitchMajority[2] & FootSwitchMajority[3]);
	if (DelayValue != 0)
		DelayValue--;
}

unsigned char
EEPROM_read(unsigned short Address)
{
	while(EECR & 0x02)	// Wait for completion of previous write
		;
	EEAR = Address;	// Set up address register
	EECR |= 0x01;	// Start eeprom read by writing EERE
	return EEDR;	// Return data from data register
}

void
EEPROM_write(unsigned short Address, unsigned char Data)
{
	if (EEPROM_read(Address) == Data)
	{
		NextEeProgReq = 1;
		return;
	}
	EEAR = Address;	// Set up address and data registers
	EEDR = Data;
	#asm("cli")
	EECR |= 0x04;	// Write logical one to EEMWE
	EECR |= 0x0A;	// Start eeprom write by setting EEWE
	#asm("sei")
}
 
void
ProgEeByte(void)
{
	if (ProgLen)
	{
		EEPROM_write(EeProgAddr, *EePtr);
		ProgLen--;
		EeProgAddr++;
		EePtr++;
	}
	else
	{
		EeProgProgress = 0;
	}
}

void
Wdog(void)
{
	#asm("wdr")
	if (NextEeProgReq)
	{
		NextEeProgReq = 0;
		ProgEeByte();
	}
}

void
Waitms(unsigned char Del)
{
	DelayValue = Del;
	while (DelayValue != 0)
	{
		Wdog();
	}
}

void
SetRelays(void)
{
	if ((HwRelayState & (CH1_ON | CH2_ON | CH3_ON | OD_STRUCTURE)) != (RelayState & (CH1_ON | CH2_ON | CH3_ON | OD_STRUCTURE)))
	{	// Turn off all channels before setting new channel
		HwRelayState &= ~(CH1_ON | CH2_ON | CH3_ON);
		PORTA = (unsigned char)(HwRelayState);
		PORTE = (unsigned char)((HwRelayState >> 8) & 0x07);
		PORTC = (unsigned char)((HwRelayState >> 5) | 0x3F);
		PORTB = (unsigned char)((HwRelayState >> 13) | 0xFE);
		Waitms(20);
		HwRelayState = RelayState;
		HwRelayState &= ~(CH1_ON | CH2_ON | CH3_ON);
		PORTA = (unsigned char)(HwRelayState);
		PORTE = (unsigned char)((HwRelayState >> 8) & 0x07);
		PORTC = (unsigned char)((HwRelayState >> 5) | 0x3F);
		PORTB = (unsigned char)((HwRelayState >> 13) | 0xFE);
		Waitms(20);
	}
	HwRelayState = RelayState;
	PORTA = (unsigned char)(HwRelayState);
	PORTE = (unsigned char)((HwRelayState >> 8) & 0x07);
	PORTC = (unsigned char)((HwRelayState >> 5) | 0x3F);
	PORTB = (unsigned char)((HwRelayState >> 13) | 0xFE);
}

void
UpdateRelaysFromFrontSwitches(void)
{
	RelayState &= ~(OD_STRUCTURE | CH1_PEQH | CH1_PEQL | CH2_PEQH | CH2_PEQL | CH3_PEQH | CH3_PEQL | PLEXI);
	if ((FrontSwitchState & _OD_STRUCTURE) != 0)
		RelayState |= OD_STRUCTURE;
	if ((FrontSwitchState & _CH1_PEQH) != 0)
		RelayState |= CH1_PEQH;
	if ((FrontSwitchState & _CH1_PEQL) != 0)
		RelayState |= CH1_PEQL;
	if ((FrontSwitchState & _CH2_PEQH) != 0)
		RelayState |= CH2_PEQH;
	if ((FrontSwitchState & _CH2_PEQL) != 0)
		RelayState |= CH2_PEQL;
	if ((FrontSwitchState & _CH3_PEQH) != 0)
		RelayState |= CH3_PEQH;
	if ((FrontSwitchState & _CH3_PEQL) != 0)
		RelayState |= CH3_PEQL;
	if (((FrontSwitchState & _PLEXI_CH2) != 0) && ((RelayState & CH2_ON) != 0))
		RelayState |= PLEXI;
	if (((FrontSwitchState & _PLEXI_CH3) != 0) && ((RelayState & CH3_ON) != 0))
		RelayState |= PLEXI;
}


void
ChkFootSwitchSettingsAltered(void)
{
	if (((FootSwitchState & (_FS_CH1_ON | _FS_CH2_ON |_FS_CH3_ON)) != 0) &&
		((PrevFootSwitchState & (_FS_CH1_ON | _FS_CH2_ON |_FS_CH3_ON)) == 0))
	{
		RelayState &= ~(CH1_ON | CH2_ON | CH3_ON | CH1_BOOST | OD_BOOST);
		if ((FootSwitchState & _FS_CH1_ON) != 0)
			RelayState |= CH1_ON;
		else if ((FootSwitchState & _FS_CH2_ON) != 0)
			RelayState |= CH2_ON;
		else if ((FootSwitchState & _FS_CH3_ON) != 0)
			RelayState |= CH3_ON;
		if ((FootSwitchState & _FS_CH1_BOOST) != 0)
			RelayState |= CH1_BOOST;
		if ((FootSwitchState & _FS_OD_BOOST) != 0)
			RelayState |= OD_BOOST;
		UpdateRelaysFromFrontSwitches();
		SetRelays();
		SwitchSettingsAltered = 1;
	}
	if ((FootSwitchState & (_FS_CH1_BOOST | _FS_OD_BOOST)) !=
		(PrevFootSwitchState & (_FS_CH1_BOOST | _FS_OD_BOOST)))
	{
		RelayState &= ~(CH1_BOOST | OD_BOOST);
		if ((FootSwitchState & _FS_CH1_BOOST) != 0)
			RelayState |= CH1_BOOST;
		if ((FootSwitchState & _FS_OD_BOOST) != 0)
			RelayState |= OD_BOOST;
		UpdateRelaysFromFrontSwitches();
		SetRelays();
		SwitchSettingsAltered = 1;
	}
	if ((FootSwitchState & (_FS_LOOP_ON)) !=
		(PrevFootSwitchState & (_FS_LOOP_ON)))
	{
		RelayState &= ~(LOOP_ON);
		if ((FootSwitchState & _FS_LOOP_ON) != 0)
			RelayState |= LOOP_ON;
		UpdateRelaysFromFrontSwitches();
		SetRelays();
		SwitchSettingsAltered = 1;
	}
}

void
ChkFrontSwitchSettingsAltered(void)
{
	if ((FrontSwitchState & (_PLEXI_CH2 |  _CH_UP |  _CH_DN | _CH1_PEQH | _CH1_PEQL | _CH1_BOOST | _PLEXI_CH3 | _OD_STRUCTURE | _OD_BOOST | _CH2_PEQL | _CH2_PEQH | _CH3_PEQL | _CH3_PEQH)) !=
		(PrevFrontSwitchState & (_PLEXI_CH2 |  _CH_UP |  _CH_DN | _CH1_PEQH | _CH1_PEQL | _CH1_BOOST | _PLEXI_CH3 | _OD_STRUCTURE | _OD_BOOST | _CH2_PEQL | _CH2_PEQH | _CH3_PEQL | _CH3_PEQH)))
	{
		RelayState &= ~(CH1_ON | CH2_ON | CH3_ON | CH1_BOOST | OD_BOOST);
		if ((FrontSwitchState & _CH_UP) != 0)
		{	//	Channel 3
			RelayState = CH3_ON;
		}
		else if ((FrontSwitchState & _CH_DN) != 0)
		{
			RelayState = CH1_ON;
		}
		else
		{
			RelayState = CH2_ON;
		}
		if ((FrontSwitchState & _CH1_BOOST) != 0)
			RelayState |= CH1_BOOST;
		if ((FrontSwitchState & _OD_BOOST) != 0)
			RelayState |= OD_BOOST;
		UpdateRelaysFromFrontSwitches();
		SetRelays();
		SwitchSettingsAltered = 1;
	}
}

void
main(void)
{
	InitHw();
	LastReceivedProgramm = 255;
	LastReceivedChannel = 255;
	MidiProgramm = 255;
	FrontSwitchState = _CH_UP | _CH_DN;
	// Global enable interrupts
	#asm("sei")
	while (1)
	{
		Wdog();
		PrevFrontSwitchState = FrontSwitchState;
		FrontSwitchState = FrontSwitchMajority[0];
		PrevFootSwitchState = FootSwitchState;
		FootSwitchState = FootSwitchMajority[0];
		ChkFootSwitchSettingsAltered();
		ChkFrontSwitchSettingsAltered();
		if (MidiProgramm != 255)
		{
			if (MidiProgramm == LastReceivedProgramm &&
				 MidiChannel == LastReceivedChannel &&
				 SwitchSettingsAltered != 0)
			{
				EeValue =  (((unsigned long)(MidiChannel)) << 16) | RelayState;
				EeProgAddr = MidiProgramm << 2;
				EePtr = (unsigned char*)(&EeValue);
				ProgLen = 4;
				ProgEeByte();
				EeProgProgress = 1;
			}
			else
			{
				EeValue = EEPROM_read((unsigned short)MidiProgramm << 2) | ((unsigned short)EEPROM_read(((unsigned short)MidiProgramm << 2) + 1) << 8) | ((unsigned long)EEPROM_read(((unsigned short)MidiProgramm << 2) + 2) << 16);
				if ((EeValue & 0xFFF00000) == 0)
				{
					StoredChannel = (EeValue >> 16) & 0x0F;
					if (StoredChannel == MidiChannel)
					{
						RelayState = EeValue & 0xFFFF;
						SetRelays();
					}
				}
			}
			LastReceivedProgramm = MidiProgramm;
			LastReceivedChannel = MidiChannel;
			SwitchSettingsAltered = 0;
			MidiProgramm = 255;
		}	
	}
}
