#include	<mega8515.h>

void
InitHw(void)
{
	// Input/Output Ports initialization
	// Port A initialization
	// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
	// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
	PORTA = 0x00;
	DDRA = 0xFF;
	// Port B initialization
	// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
	// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
	PORTB = 0xFE;
	DDRB = 0x01;
	// Port C initialization
	// Func7=Out Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
	// State7=0 State6=0 State5=P State4=P State3=P State2=P State1=P State0=P 
	PORTC = 0x3F;
	DDRC = 0xC0;
	// Port D initialization
	// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
	// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
	PORTD = 0xFF;
	DDRD = 0x00;
	// Port E initialization
	// Func2=Out Func1=Out Func0=Out 
	// State2=0 State1=0 State0=0 
	PORTE = 0x00;
	DDRE = 0x07;
	// Timer/Counter 0 initialization
	// Clock source: System Clock
	// Clock value: Timer 0 Stopped
	// Mode: Normal top=FFh
	// OC0 output: Disconnected
	TCCR0=0x00;
	TCNT0=0x00;
	OCR0=0x00;
	// Timer/Counter 1 initialization
	// Clock source: System Clock
	// Clock value: 1000,000 kHz
	// Mode: Normal top=FFFFh
	// OC1A output: Discon.
	// OC1B output: Discon.
	// Noise Canceler: Off
	// Input Capture on Falling Edge
	// Timer 1 Overflow Interrupt: Off
	// Input Capture Interrupt: Off
	// Compare A Match Interrupt: On
	// Compare B Match Interrupt: Off
	TCCR1A = 0x00;
	TCCR1B = 0x02;
	TCNT1H = 0x00;
	TCNT1L = 0x00;
	ICR1H = 0x00;
	ICR1L = 0x00;
	OCR1AH = 0x00;
	OCR1AL = 0x00;
	OCR1BH = 0x00;
	OCR1BL = 0x00;
	// External Interrupt(s) initialization
	// INT0: Off
	// INT1: Off
	// INT2: Off
	MCUCR = 0x00;
	EMCUCR = 0x00;
	// Timer(s)/Counter(s) Interrupt(s) initialization
	TIMSK = 0x40;
	// USART initialization
	// Communication Parameters: 8 Data, 1 Stop, No Parity
	// USART Receiver: On
	// USART Transmitter: On
	// USART Mode: Asynchronous
	// USART Baud rate: 31250
	UCSRA = 0x00;
	UCSRB = 0x98;
	UCSRC = 0x86;
	UBRRH = 0x00;
	UBRRL = 0x0F;
	// Analog Comparator initialization
	// Analog Comparator: Off
	// Analog Comparator Input Capture by Timer/Counter 1: Off
	ACSR = 0x80;
}